// derived from http://love2d.org/wiki/HSV_color

vec3 hsv(float h, float s, float v)
{
    if (s <= 0) { return vec3(v); }

    h *= 6;

    float c = v * s;
    float x = (1 - abs(mod(h, 2) - 1)) * c;
    
    vec3 m = vec3(v - c);
    vec3 colour;

         if (h < 1) { colour = vec3(c, x, 0); }
    else if (h < 2) { colour = vec3(x, c, 0); }
    else if (h < 3) { colour = vec3(0, c, x); }
    else if (h < 4) { colour = vec3(0, x, c); }
    else if (h < 5) { colour = vec3(x, 0, c); }
    else            { colour = vec3(c, 0, x); }

    return colour + m;
}
